---
title: AudioWorkletNode.port
slug: Web/API/AudioWorkletNode/port
tags:
  - API
  - AudioWorkletNode
  - Property
  - Reference
  - Web Audio API
  - port
---
<div>{{APIRef("Web Audio API")}}{{SeeCompatTable}}</div>

<p class="summary">The read-only <strong><code>port</code></strong> property of the {{domxref("AudioWorkletNode")}} interface returns the associated {{domxref("MessagePort")}}. It can be used to communicate between the node and its associated {{domxref("AudioWorkletProcessor")}}.</p>

<div class="notecard note">
<p class="summary"><strong>Note</strong>: The port at the other end of the channel is available under the {{domxref("AudioWorkletProcessor.port", "port")}} property of the processor.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>audioWorkletNodeInstance</em>.port;</pre>

<h3 id="Value">Value</h3>

<p>The {{domxref("MessagePort")}} object that is connecting the <code>AudioWorkletNode</code> and its associated <code>AudioWorkletProcessor</code>.</p>

<h2 id="Examples">Examples</h2>

<p>To demonstrate bidirectional communication capabilities, we'll create an <code>AudioWorkletProcessor</code>, which will output silence and respond to ping requests from its <code>AudioWorkletNode</code>.</p>

<p>First, we need to define a custom <code>AudioWorkletProcessor</code>, and register it. Note that this should be done in a separate file.</p>

<pre class="brush: js notranslate">// ping-pong-processor.js
class PingPongProcessor extends AudioWorkletProcessor {
  constructor (...args) {
    super(...args)
    this.port.onmessage = (e) =&gt; {
      console.log(e.data)
      this.port.postMessage('pong')
    }
  }
  process (inputs, outputs, parameters) {
    return true
  }
}

registerProcessor('ping-pong-processor', PingPongProcessor)
</pre>

<p>Now in our main scripts file we'll load the processor, create an instance of <code>AudioWorkletNode</code> passing the name of the processor, and connect the node to an audio graph.</p>

<pre class="brush: js notranslate">const audioContext = new AudioContext()
await audioContext.audioWorklet.addModule('ping-pong-processor.js')
const pingPongNode = new AudioWorkletNode(audioContext, 'ping-pong-processor')
// send the message containing 'ping' string
// to the AudioWorkletProcessor from the AudioWorkletNode every second
setInterval(() =&gt; pingPongNode.port.postMessage('ping'), 1000)
pingPongNode.port.onmessage = (e) =&gt; console.log(e.data)
pingPongNode.connect(audioContext.destination)
</pre>

<p>This will output <code>"ping"</code> and <code>"pong"</code> strings to the console every second.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audioworkletnode-port', 'port')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioWorkletNode.port")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
